<?php

// URL GEPI
$carnets_de_liaison_url_gepi=getSettingValue("carnets_de_liaison_url_gepi");

// nom de domaine pour l'envoi de notification
$carnets_de_liaison_email_notification=getSettingValue("carnets_de_liaison_email_notification");

function message_d_erreur_mail($errno, $errstr)
	{
	/*
	E_ERROR           => "Erreur",
	E_WARNING         => "Alerte",
	E_PARSE           => "Erreur d'analyse",
	E_NOTICE          => "Note",
	E_CORE_ERROR      => "Core Error",
	E_CORE_WARNING    => "Core Warning",
	E_COMPILE_ERROR   => "Compile Error",
	E_COMPILE_WARNING => "Compile Warning",
	E_USER_ERROR      => "Erreur spcifique",
	E_USER_WARNING    => "Alerte spcifique",
	E_USER_NOTICE     => "Note spcifique",
	E_STRICT          => "Runtime Notice"
	*/
	global $message_d_erreur_mail;
	switch ($errno)
		{
		case E_ERROR :
		case E_WARNING :
		case E_NOTICE :
			//$message_d_erreur_mail=preg_replace('/&/','//',$errstr);
			$message_d_erreur_mail=html_entity_decode($errstr);
			break;
		default :
			$message_d_erreur="Erreur PHP ".$errno;
		}
	}

function envoi_courriel_notification($to,$subject,$bcc,$message,$redacteur)
	{
	global $carnets_de_liaison_email_notification;
	$bcc.=$_SESSION['prenom']." ".$_SESSION['nom']."<".$redacteur['email'].">";
	$subject = "=?ISO-8859-1?B?".base64_encode($subject)."?=";
	$headers="From: [GEPI- carnets de liaison]  <".$carnets_de_liaison_email_notification.">".PHP_EOL;
	$headers.="Content-type: text/plain; charset=iso-8859-1".PHP_EOL;
	$headers.="MIME-Version: 1.0".PHP_EOL;
	$headers.="Bcc: ".$bcc."".PHP_EOL;
	return (@mail($to, $subject, $message, $headers))?"OK":"echec";
	}

function envoi_notification($ids,$type)
	{
	global $gepiPath,$carnets_de_liaison_email_notification,$carnets_de_liaison_url_gepi;
	$r_sql="SELECT `civilite`,`prenom`,`nom`,`email` FROM `utilisateurs` WHERE `login`='".$_SESSION['login']."' LIMIT 1";
	$R_redacteur=mysql_query($r_sql);
	if ($R_redacteur && mysql_num_rows($R_redacteur)==1) $redacteur=mysql_fetch_assoc($R_redacteur);
		else $redacteur=array("","","","");
	// si le rdacteur n'a pas de mail dans GEPI on utilise le mail spcifi dans le mot
	if ($redacteur['email']=="" && isset($_POST['mail'])) $redacteur['email']=$_POST['mail'];
	// si le rdacteur n'a pas de mail on n'envoie pas de notification
	if ($redacteur['email']=="") return "no_email_redacteur";
	
	$bcc="";
	switch ($type)
		{
		case "eleve" :
			//$r_sql="SELECT DISTINCT CONCAT_WS('',`eleves`.`prenom`,' ',`eleves`.`nom`) AS `nom_eleve`,`utilisateurs`.`prenom`,`utilisateurs`.`nom`,`utilisateurs`.`email` FROM `eleves`,`responsables2`,`resp_pers`,`utilisateurs` WHERE `utilisateurs`.`email`<>'' AND (FIND_IN_SET(`eleves`.`ele_id`,'".$ids."') AND `eleves`.`ele_id`=`responsables2`.`ele_id` AND `responsables2`.`pers_id`=`resp_pers`.`pers_id` AND `resp_pers`.`login`=`utilisateurs`.`login`) ";
			$r_sql="SELECT DISTINCT CONCAT_WS('',`eleves`.`prenom`,' ',`eleves`.`nom`) AS `nom_eleve`,`utilisateurs`.`email` FROM `eleves`,`responsables2`,`resp_pers`,`utilisateurs` WHERE `utilisateurs`.`email`<>'' AND (FIND_IN_SET(`eleves`.`ele_id`,'".$ids."') AND `eleves`.`ele_id`=`responsables2`.`ele_id` AND `responsables2`.`pers_id`=`resp_pers`.`pers_id` AND `resp_pers`.`login`=`utilisateurs`.`login`) ";
			$R_responsables=mysql_query($r_sql);
			if ($R_responsables && mysql_num_rows($R_responsables)>0)
				{
				if (mysql_num_rows($R_responsables)<=10)
					{
					// on envoie une notification personalise
					while ($un_responsable=mysql_fetch_assoc($R_responsables))
						{
						$subject="Carnet de liaison de ".$un_responsable['nom_eleve'];
						$message="Nouveau mot rdig par ".$redacteur['civilite']." ".$redacteur['prenom']." ".$redacteur['nom']."\ndans le carnet de liaison de ".$un_responsable['nom_eleve']." :\n".stripslashes($_POST['intitule']);
						$message.="\n\n".$carnets_de_liaison_url_gepi;
						return envoi_courriel_notification($un_responsable['email'],$subject,"",$message,$redacteur);
						}
					}
				else
					{
					// notification simple
					$subject="Carnet de liaison";
					$message="Nouveau mot rdig par ".$redacteur['civilite']." ".$redacteur['prenom']." ".$redacteur['nom']."\ndans le carnet de liaison :\n".stripslashes($_POST['intitule']);;
					$message.="\n\n".$carnets_de_liaison_url_gepi;
					while ($un_destinataire=mysql_fetch_assoc($R_destinataires)) $bcc.=$un_destinataire['email'].",";
					return envoi_courriel_notification("",$subject,$bcc,$message,$redacteur);
					}
				}
			else  return "no_email_responsable";
			break;
		default :
		
			switch ($type)
				{
				case "classe" :
					$r_sql="SELECT GROUP_CONCAT(`classes`.`nom_complet`) AS `ensemble` FROM `classes` WHERE FIND_IN_SET(`classes`.`id`,'".$ids."')";
					$R_ensemble=mysql_query($r_sql);
					$ensemble=($R_ensemble && mysql_num_rows($R_ensemble)==1)?mysql_result($R_ensemble,0):"";
					//$r_sql="SELECT DISTINCT `classes`.`nom_complet` AS 'nom_classe','".$ensemble."' AS `ensemble`, `utilisateurs`.`prenom`,`utilisateurs`.`nom`,`utilisateurs`.`email` FROM `classes`,`j_eleves_classes`,`eleves`,`responsables2`,`resp_pers`,`utilisateurs` WHERE FIND_IN_SET(`classes`.`id`,'".$ids."') AND  `classes`.`id`=`j_eleves_classes`.`id_classe` AND `j_eleves_classes`.`login`=`eleves`.`login` AND `eleves`.`ele_id`=`responsables2`.`ele_id` AND `responsables2`.`resp_legal`<>0 AND `responsables2`.`pers_id`=`resp_pers`.`pers_id` AND `resp_pers`.`login`=`utilisateurs`.`login` ORDER BY `classes`.`nom_complet`,`utilisateurs`.`nom`,`utilisateurs`.`prenom`";
					$r_sql="SELECT DISTINCT `classes`.`nom_complet` AS 'nom_classe','".$ensemble."' AS `ensemble`, `utilisateurs`.`prenom`,`utilisateurs`.`nom`,`utilisateurs`.`email` FROM `classes`,`j_eleves_classes`,`eleves`,`responsables2`,`resp_pers`,`utilisateurs` WHERE `utilisateurs`.`email`<>'' AND FIND_IN_SET(`classes`.`id`,'".$ids."') AND  `classes`.`id`=`j_eleves_classes`.`id_classe` AND `j_eleves_classes`.`login`=`eleves`.`login` AND `eleves`.`ele_id`=`responsables2`.`ele_id` AND `responsables2`.`resp_legal`<>0 AND `responsables2`.`pers_id`=`resp_pers`.`pers_id` AND `resp_pers`.`login`=`utilisateurs`.`login` ORDER BY `classes`.`nom_complet`,`utilisateurs`.`nom`,`utilisateurs`.`prenom`";
					break;
				case "groupe" :
					$r_sql="SELECT GROUP_CONCAT(`classes`.`nom_complet`) AS `ensemble` FROM `classes`,`j_groupes_classes`,`groupes` WHERE `groupes`.`id`='".$ids."' AND `j_groupes_classes`.`id_groupe`=`groupes`.`id` AND `j_groupes_classes`.`id_classe`=`classes`.`id` GROUP BY `groupes`.`id`";
					$R_ensemble=mysql_query($r_sql);
					$ensemble=($R_ensemble && mysql_num_rows($R_ensemble)==1)?mysql_result($R_ensemble,0):"";
					$r_sql="SELECT `groupes`.`description` FROM `groupes` WHERE `groupes`.`id`='".$ids."'";
					$R_ensemble=mysql_query($r_sql);
					$ensemble=(($R_ensemble && mysql_num_rows($R_ensemble)==1)?mysql_result($R_ensemble,0):"")." ".$ensemble;
					//$r_sql="SELECT DISTINCT DISTINCT '".$ensemble."' AS `ensemble`,`utilisateurs`.`prenom`,`utilisateurs`.`nom`,`utilisateurs`.`email` FROM `groupes`,`j_eleves_groupes`,`eleves`,`responsables2`,`resp_pers`,`utilisateurs` WHERE `groupes`.`id`='".$ids."' AND  `groupes`.`id`=`j_eleves_groupes`.`id_groupe` AND `j_eleves_groupes`.`login`=`eleves`.`login` AND `eleves`.`ele_id`=`responsables2`.`ele_id` AND `responsables2`.`resp_legal`<>0 AND `responsables2`.`pers_id`=`resp_pers`.`pers_id` AND `resp_pers`.`login`=`utilisateurs`.`login`";
					$r_sql="SELECT DISTINCT DISTINCT '".$ensemble."' AS `ensemble`,`utilisateurs`.`prenom`,`utilisateurs`.`nom`,`utilisateurs`.`email` FROM `groupes`,`j_eleves_groupes`,`eleves`,`responsables2`,`resp_pers`,`utilisateurs` WHERE `utilisateurs`.`email`<>'' AND `groupes`.`id`='".$ids."' AND  `groupes`.`id`=`j_eleves_groupes`.`id_groupe` AND `j_eleves_groupes`.`login`=`eleves`.`login` AND `eleves`.`ele_id`=`responsables2`.`ele_id` AND `responsables2`.`resp_legal`<>0 AND `responsables2`.`pers_id`=`resp_pers`.`pers_id` AND `resp_pers`.`login`=`utilisateurs`.`login`";
					break;
				case "aid" :
					$r_sql="SELECT `aid`.`nom` FROM `aid` WHERE `aid`.`id`='".$ids."'";
					$R_ensemble=mysql_query($r_sql);
					$ensemble=($R_ensemble && mysql_num_rows($R_ensemble)==1)?mysql_result($R_ensemble,0):"";
					//$r_sql="SELECT DISTINCT `aid`.`nom` AS `ensemble`,`utilisateurs`.`prenom`,`utilisateurs`.`nom`,`utilisateurs`.`email` FROM `aid`,`j_aid_eleves`,`eleves`,`responsables2`,`resp_pers`,`utilisateurs` WHERE `aid`.`id`='".$ids."' AND  `aid`.`id`=`j_aid_eleves`.`id_aid` AND `j_aid_eleves`.`login`=`eleves`.`login` AND `eleves`.`ele_id`=`responsables2`.`ele_id` AND `responsables2`.`resp_legal`<>0 AND `responsables2`.`pers_id`=`resp_pers`.`pers_id` AND `resp_pers`.`login`=`utilisateurs`.`login`";
					$r_sql="SELECT DISTINCT `aid`.`nom` AS `ensemble`,`utilisateurs`.`prenom`,`utilisateurs`.`nom`,`utilisateurs`.`email` FROM `aid`,`j_aid_eleves`,`eleves`,`responsables2`,`resp_pers`,`utilisateurs` WHERE `utilisateurs`.`email`<>'' AND `aid`.`id`='".$ids."' AND  `aid`.`id`=`j_aid_eleves`.`id_aid` AND `j_aid_eleves`.`login`=`eleves`.`login` AND `eleves`.`ele_id`=`responsables2`.`ele_id` AND `responsables2`.`resp_legal`<>0 AND `responsables2`.`pers_id`=`resp_pers`.`pers_id` AND `resp_pers`.`login`=`utilisateurs`.`login`";
					break;
				}

			switch ($type)
				{
				case "classe" :
					$classes_destinataires=(count(explode(",",$ensemble))>1)?"des classes ":"de la classe ";
					$subject="Carnet de liaison ".$classes_destinataires.$ensemble;
					$message="Nouveau mot rdig par ".$redacteur['civilite']." ".$redacteur['prenom']." ".$redacteur['nom']."\ndans le carnet de liaison des lves ".$classes_destinataires.$ensemble." :\n".stripslashes($_POST['intitule']);
					$message.="\n\n".$carnets_de_liaison_url_gepi;
					break;
				case "aid" :
				case "groupe" :
					$subject="Carnet de liaison de ".$ensemble;
					$message="Nouveau mot rdig par ".$redacteur['civilite']." ".$redacteur['prenom']." ".$redacteur['nom']."\ndans le carnet de liaison des lves de ".$ensemble." :\n".stripslashes($_POST['intitule']);
					$message.="\n\n".$carnets_de_liaison_url_gepi;
				}
				
				$R_destinataires=mysql_query($r_sql);
				if ($R_destinataires && mysql_num_rows($R_destinataires)>0)
					{
					while ($un_destinataire=mysql_fetch_assoc($R_destinataires)) $bcc.=$un_destinataire['email'].",";
					return envoi_courriel_notification("",$subject,$bcc,$message,$redacteur);
					}
				else return "no_email_responsable";
		}
	}
?>